/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.region;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.bausystem.region.Region;
import de.steamwar.bausystem.region.RegionUtils;
import de.steamwar.bausystem.region.flags.Flag;
import de.steamwar.bausystem.region.flags.ProtectMode;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class ProtectCommand extends SWCommand {

    public ProtectCommand() {
        super("protect");
    }

    @Register(description = "REGION_PROTECT_HELP")
    public void genericProtectCommand(@Validator Player p) {
        Region region = regionCheck(p);
        if (region == null) return;
        if (region.getRegionData().get(Flag.PROTECT).isWithDefault(ProtectMode.ACTIVE)) {
            region.getRegionData().set(Flag.PROTECT, ProtectMode.INACTIVE);
            RegionUtils.actionBar(region, "REGION_PROTECT_DISABLE");
        } else {
            region.getRegionData().set(Flag.PROTECT, ProtectMode.ACTIVE);
            RegionUtils.actionBar(region, "REGION_PROTECT_ENABLE");
        }
    }

    private Region regionCheck(Player player) {
        Region region = Region.getRegion(player.getLocation());
        if (!region.getRegionData().has(Flag.PROTECT).isApplicable()) {
            BauSystem.MESSAGE.send("REGION_PROTECT_FALSE_REGION", player);
            return null;
        }
        return region;
    }
}
